// Mod: Tiles for Xin Calendar 2 (In-Page)
// Copyright 2004  Xin Yang    All Rights Reserved.

// Last Modified: 20-Aug-2004

// User interface
function addTiles(confName,tileCornerWidth,tileCornerHeight,cssTileTL,cssTileTC,cssTileTR,cssTileCL,cssTileCC,cssTileCR,cssTileBL,cssTileBC,cssTileBR) {
  xcRegisterConf(confName,"tiles","tiles",{"width":tileCornerWidth,"height":tileCornerHeight,"tiles":[cssTileTL||"",cssTileTC||"",cssTileTR||"",cssTileCL||"",cssTileCC||"",cssTileCR||"",cssTileBL||"",cssTileBC||"",cssTileBR||""],"calWidth":0,"calHeight":0,"id":""},0);
}

// Internal function
var xcIdSeq=0;

function xcOneTile(w,h,css) { return "<TD><DIV CLASS='"+css+"' STYLE='width:"+w+"px; height:"+h+"px; font-size:1px; line-height:1px;'></DIV></TD>"; }
function xcMakeTiles(tile) {
  var tileWidth=tile.calWidth-tile.width*2, tileHeight=tile.calHeight-tile.height*2;
  return "<TABLE WIDTH='"+tile.calWidth+"' HEIGHT='"+tile.calHeight+"' CELLPADDING='0' CELLSPACING='0' BORDER='0'><TR>"
       + xcOneTile(tile.width,tile.height,tile.tiles[0])
       + xcOneTile(tileWidth,tile.height,tile.tiles[1])
       + xcOneTile(tile.width,tile.height,tile.tiles[2])
       + "</TR><TR>"
       + xcOneTile(tile.width,tileHeight,tile.tiles[3])
       + xcOneTile(tileWidth,tileHeight,tile.tiles[4])
       + xcOneTile(tile.width,tileHeight,tile.tiles[5])
       + "</TR><TR>"
       + xcOneTile(tile.width,tile.height,tile.tiles[6])
       + xcOneTile(tileWidth,tile.height,tile.tiles[7])
       + xcOneTile(tile.width,tile.height,tile.tiles[8])
       + "</TR></TABLE>";
}

// Overloaded function
function xcAddOn1() {
  var hasTile=this.getConf("tiles","tiles"), addOn="";

  if (hasTile) {
    if (hasTile.calWidth!=0) {
      addOn="<DIV STYLE='position:absolute; z-index:1;'>"+xcMakeTiles(hasTile)+xcDIVClose;
    }
    else {
      hasTile.id=xcIdSeq++;
      addOn="<DIV ID='tile"+hasTile.id+"' STYLE='position:absolute; z-index:1;'>"+xcDIVClose;
    }
  }

  return addOn;
}

function xcBeforeShow() {
  var hasTile=this.getConf("tiles","tiles");

  if (hasTile && hasTile.calWidth==0) {
    hasTile.calWidth=this.holder.offsetWidth;
    hasTile.calHeight=this.holder.offsetHeight;

    xcWriteLayer(xcGetHolder("tile"+hasTile.id),xcMakeTiles(hasTile));
  }
}
