// Mod: Long Date Format for Xin Calendar 2 (In-Page/Popup-Window)
// Copyright 2004  Xin Yang    All Rights Reserved.

// Last Modified: 20-Aug-2004

// Internal functions
var xcDateFormatLong=xcDateFormat, xcMonthRE=xcWeekRE=null;

xcDateFormat=xcDateFormat.replace(/month/i, "mm");
xcDateFormat=xcDateFormat.replace(/week/i, "week");

function xcGetMonthRE() {
  if (xcMonthRE==null) {
    xcMonthRE=new RegExp("("+xcMonthNames.join("|")+")", 'i');
  }
  return xcMonthRE;
}

function xcGetWeekRE() {
  if (xcWeekRE==null) {
    xcWeekRE=new RegExp("("+xcWeekdayNames.join("|")+")", 'i');
  }
  return xcWeekRE;
}

// Overloaded functions
function xcAfterGet(date) {
  if (date!="" && xcDateFormatLong.search(/month/i)!=-1) {
    var monthIdx=date.search(xcGetMonthRE());

    if (monthIdx!=-1) {
      var mm=xcGetDD(xcMonthFromName(RegExp.$1.substring(0,3))+1);
      date=date.substring(0,monthIdx)+mm+date.substring(monthIdx+RegExp.$1.length);
    }
    else {
      date="";
    }
  }

  if (date!="" && xcDateFormatLong.search(/week/i)!=-1) {
    var dayIdx=date.search(xcGetWeekRE());

    if (dayIdx!=-1) {
      date=date.substring(0,dayIdx)+"week"+date.substring(dayIdx+RegExp.$1.length);
    }
    else {
      date="";
    }
  }

  return afterGetDateValue(this.refField,this.targetField,date);
}

function xcBeforeUpdate(date) {
  if (date!="") {
    var dateYMD=xcGetYMDFromDate(date);

    if (xcDateFormatLong.search(/month/i)!=-1) {
      var monthIdx=xcDateFormat.search(/mm/);

      if (xcDateFormatLong.search(/Month/)!=-1) {
        date=date.substring(0,monthIdx)+xcMonthNames[dateYMD[1]]+date.substring(monthIdx+2);
      }
      else {
        date=date.substring(0,monthIdx)+xcMonthNames[dateYMD[1]].toUpperCase()+date.substring(monthIdx+2);
      }
    }

    if (xcDateFormatLong.search(/week/i)!=-1) {
      var dayIdx=date.search(/week/), dayName=xcWeekdayNames[(new Date(dateYMD[0],dateYMD[1],dateYMD[2])).getDay()];

      if (xcDateFormatLong.search(/Week/)!=-1) {
        date=date.substring(0,dayIdx)+dayName+date.substring(dayIdx+4);
      }
      else {
        date=date.substring(0,dayIdx)+dayName.toUpperCase()+date.substring(dayIdx+4);
      }
    }
  }

  return beforeSetDateValue(this.refField,this.targetField,date);
}
